build_helper 27.8 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34
#/*
# * Licensed to the OpenAirInterface (OAI) Software Alliance under one or more
# * contributor license agreements.  See the NOTICE file distributed with
# * this work for additional information regarding copyright ownership.
# * The OpenAirInterface Software Alliance licenses this file to You under
# * the OAI Public License, Version 1.1  (the "License"); you may not use this file
# * except in compliance with the License.
# * You may obtain a copy of the License at
# *
# *      http://www.openairinterface.org/?page_id=698
# *
# * Unless required by applicable law or agreed to in writing, software
# * distributed under the License is distributed on an "AS IS" BASIS,
# * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# * See the License for the specific language governing permissions and
# * limitations under the License.
# *-------------------------------------------------------------------------------
# * For more information about the OpenAirInterface (OAI) Software Alliance:
# *      contact@openairinterface.org
# */

# file build_helper
# brief
# authors Laurent Thomas, Lionel GAUTHIER
#
#######################################
if [ ! -f /etc/os-release ]; then
  echo "No /etc/os-release file found. You're likely on an unsupported distro."
  exit -1
fi
OS_DISTRO=$(grep "^ID=" /etc/os-release | sed "s/ID=//" | sed "s/\"//g")
OS_RELEASE=$(grep "^VERSION_ID=" /etc/os-release | sed "s/VERSION_ID=//" | sed "s/\"//g")
case "$OS_DISTRO" in
  fedora) OS_BASEDISTRO="fedora"; INSTALLER="dnf"; CMAKE="cmake" ;;
35
  rhel)   OS_BASEDISTRO="fedora"; INSTALLER="yum --skip-broken"; CMAKE="cmake3" ;;
36
  centos) OS_BASEDISTRO="centos"; INSTALLER="yum --skip-broken"; CMAKE="cmake3" ;;
37 38 39 40 41 42
  debian) OS_BASEDISTRO="debian"; INSTALLER="apt-get"; CMAKE="cmake" ;;
  ubuntu) OS_BASEDISTRO="debian"; INSTALLER="apt-get"; CMAKE="cmake" ;;
esac
KERNEL_VERSION=$(uname -r | cut -d '.' -f1)
KERNEL_MAJOR=$(uname -r | cut -d '.' -f2)

43
#check if we run inside a container
44
IS_CONTAINER=`egrep -c "docker|podman|kubepods|libpod|buildah" /proc/self/cgroup || true`
45 46
#sudo is not needed when we are root
if [ "$UID" = 0 ]
47 48
then
  SUDO=''
49 50
else
  SUDO='sudo -S -E'
51
fi
52 53 54 55 56 57 58 59 60 61 62 63 64 65 66

###############################
## echo and  family
###############################
black='\E[30m'
red='\E[31m'
green='\E[32m'
yellow='\E[33m'
blue='\E[1;34m'
magenta='\E[35m'
cyan='\E[36m'
white='\E[37m'
reset_color='\E[00m'
COLORIZE=1

67
cecho()  {
68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105
    # Color-echo
    # arg1 = message
    # arg2 = color
    local default_msg="No Message."
    message=${1:-$default_msg}
    color=${2:-$green}
    [ "$COLORIZE" = "1" ] && message="$color$message$reset_color"
    echo -e "$message"
    return
}

echo_error()   { cecho "$*" $red          ;}
echo_fatal()   { cecho "$*" $red; exit -1 ;}
echo_warning() { cecho "$*" $yellow       ;}
echo_success() { cecho "$*" $green        ;}
echo_info()    { cecho "$*" $blue         ;}

########################
# distribution helpers #
########################

# This function return a string to identify the distribution we are running
# If we can't check the distribution, it returns "Unknown"
# This function return always true as exit code by design
# Examples:
#   ubuntu16.04
#   debian8.5
get_distribution_release() {
    if [[ ! -z "$OS_DISTRO$OS_RELEASE" ]]; then
        echo "$OS_DISTRO$OS_RELEASE"
    else
        echo Unknown
    fi
}

check_supported_distribution() {
    local distribution=$(get_distribution_release)
    case "$distribution" in
Robert Schmidt's avatar
Robert Schmidt committed
106
        "ubuntu22.04") return 0 ;;
107 108
        "ubuntu21.04") return 0 ;;
        "ubuntu20.04") return 0 ;;
109
        "ubuntu18.04") return 0 ;;
110
        "ubuntu16.04") return 0 ;;
111
        "fedora35")    return 0 ;;
112
        "fedora36")    return 0 ;;
113
        "rhel7")       return 0 ;;
cig's avatar
cig committed
114
        "rhel7.6")     return 0 ;;
115
        "rhel7.7")     return 0 ;;
116
        "rhel7.8")     return 0 ;;
Eurecom's avatar
Eurecom committed
117
        "rhel7.9")     return 0 ;;
118
        "rhel8.2")     return 0 ;;
119 120
        "rhel8.3")     return 0 ;;
        "rhel8.4")     return 0 ;;
121 122 123
        "rhel8.5")     return 0 ;;
        "rhel8.6")     return 0 ;;
        "rhel8.7")     return 0 ;;
Eurecom's avatar
Eurecom committed
124
        "rhel9.0")     return 0 ;;
125
        "centos7")     return 0 ;;
126
        "centos8")     return 0 ;;
127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169
    esac
    return 1
}

##################
# Error handlers #
##################

handler_EXIT() {
	local exit_code=$?
    [ "$exit_code" -eq 0 ] || echo_error "build have failed"
	exit $exit_code
}

trap handler_EXIT EXIT

###########################
# Cleaners
###########################

clean_kernel() {
    $SUDO modprobe ip_tables
    $SUDO modprobe x_tables
    $SUDO iptables -P INPUT ACCEPT
    $SUDO iptables -F INPUT
    $SUDO iptables -P OUTPUT ACCEPT
    $SUDO iptables -F OUTPUT
    $SUDO iptables -P FORWARD ACCEPT
    $SUDO iptables -F FORWARD
    $SUDO iptables -t nat -F
    $SUDO iptables -t mangle -F
    $SUDO iptables -t filter -F
    $SUDO iptables -t raw -F
    echo_info "Flushed iptables"
    $SUDO rmmod nasmesh > /dev/null 2>&1
    $SUDO rmmod oai_nw_drv  > /dev/null 2>&1
    $SUDO rmmod ue_ip > /dev/null 2>&1
    echo_info "removed drivers from kernel"
}

clean_all_files() {
 set_openair_env
 dir=$OPENAIR_DIR/cmake_targets
laurent's avatar
laurent committed
170 171
 rm -rf $dir/ran_build $dir/ran_build_noLOG
 rm -rf $dir/lte-simulators/build 
172
 rm -rf $dir/nas_sim_tools/build 
173
 rm -rf $dir/oaisim_build_oai/build $dir/oaisim_build_oai/CMakeLists.txt
174
 rm -rf $dir/autotests/bin $dir/autotests/log $dir/autotests/*/build
175 176 177 178 179 180 181 182 183 184 185 186 187 188
}

###################################
# Compilers
###################################

#check_warnings:
#    print error message if the compilation had warnings
#argument:
#    $1: log file
check_warnings() {
  #we look for 'warning:' in the compilation log file
  #this is how gcc starts a warning
  #this is not perfect, we may get false positive
189
  warning_count=`grep "warning:" "$1" | egrep -v "jobserver unavailable|disabling jobserver mode" | wc -l`
190 191 192 193 194
  if [ $warning_count -gt 0 ]; then
    echo_error "WARNING: $warning_count warnings. See $1"
  fi
}

195 196 197 198 199
#check_errors:
#    print error message if the compilation had errors
#argument:
#    $1: log file
check_errors() {
200 201
  #we look for 'error:' in the compilation log file
  error_count=`grep -c "error:" "$1"`
202 203 204 205 206
  if [ $error_count -gt 0 ]; then
    echo_error "ERROR: $error_count error. See $1"
  fi
}

207 208
compilations() {
  cd $OPENAIR_DIR/cmake_targets/$1/build
209
  echo_info "Log file for compilation is being written to: $dlog/$2.txt"
210 211
  set +e
  {
212 213 214 215 216
    if [ "$BUILD_COVERITY_SCAN" == "1" ]; then
        COV_SCAN_PREFIX="cov-build --dir cov-int"
    else
        COV_SCAN_PREFIX=""
    fi
laurent's avatar
laurent committed
217 218 219
    if [ "$MAKE_CMD" != "" ]; then
       $MAKE_CMD $2
    else 
220
    if [ "$VERBOSE_COMPILE" == "1" ]; then
221
       $COV_SCAN_PREFIX make -j`nproc` $2 VERBOSE=$VERBOSE_COMPILE
222
    else
223
       $COV_SCAN_PREFIX make -j`nproc` $2
224
    fi
laurent's avatar
laurent committed
225
    fi
226
    ret=$?
227
  } > $dlog/$2.txt 2>&1
228
  set -e
229
  if [ "$VERBOSE_CI" == "1" ]; then
230 231 232
     echo_info "====== Start of log for $2.txt ======"
     cat $dlog/$2.txt
     echo_info "====== End of log for $2.txt ======"
233
  fi
234 235
  check_warnings "$dlog/$2.txt"
  if [[ $ret -eq 0 ]]; then
236 237
     echo_success "$2 compiled"
  else
238
     check_errors "$dlog/$2.txt"
239 240 241 242 243 244 245 246 247 248 249 250 251
     echo_error "$2 compilation failed"
     exit 1
  fi
}

############################################
# External packages installers
############################################

install_usrp_uhd_driver_from_source(){
    uhd_install_log=$OPENAIR_DIR/cmake_targets/log/uhd_install_log.txt
    echo_info "\nInstalling UHD driver from sources. The log file for UHD driver installation is here: $uhd_install_log "
    (
Raphael Defosseux's avatar
Raphael Defosseux committed
252
    pushd /tmp
253
    echo "Cloning UHD driver repository"
254 255 256
    rm -rf /tmp/uhd
    git clone https://github.com/EttusResearch/uhd.git
    cd uhd
257 258
    # For our legacy TDD eNB running with a B2xx RF board
    # the following patch has to be applied
259 260
    if [[ -v UHD_VERSION ]]; then
        git checkout tags/v${UHD_VERSION}
261 262 263 264 265
        # We recommend to use not older than 3.15.0.0
        if [[ "$UHD_VERSION" == "3.15.0.0" ]]; then
            # Tested that patch for the following versions:
            # - 3.15.0.0
            git apply $OPENAIR_DIR/cmake_targets/tools/uhd-3.15-tdd-patch.diff
266
            ret=$?;[[ $ret -ne 0 ]] && echo_fatal "Could not apply the TDD patch"
267 268 269 270 271 272 273 274 275
        else
            # Tested that patch for the following versions:
            # - 4.0.0.0
            # - 4.1.0.0
            # - 4.1.0.5
            # - 4.2.0.0
            # - 4.2.0.1
            # - 4.3.0.0-rc1
            git apply $OPENAIR_DIR/cmake_targets/tools/uhd-4.x-tdd-patch.diff
276
            ret=$?;[[ $ret -ne 0 ]] && echo_fatal "Could not apply the TDD patch"
277
        fi
278 279
    else
        git checkout tags/v4.0.0.0
280
        git apply $OPENAIR_DIR/cmake_targets/tools/uhd-4.x-tdd-patch.diff
281
        ret=$?;[[ $ret -ne 0 ]] && echo_fatal "Could not apply the TDD patch"
282
    fi
283 284
    # Printing out the results of the patch to make sure it was properly applied
    git diff
285
    mkdir -p host/build
286 287
    cd host/build || true
    $CMAKE ../ -GNinja
288
    echo "Compiling UHD"
289 290
    ninja
    $SUDO ninja install
Raphael Defosseux's avatar
Raphael Defosseux committed
291
    $SUDO ldconfig -v
292 293 294 295 296 297 298 299
    if [ $IS_CONTAINER -eq 0 ]; then
        if [[ "$OS_DISTRO" == "ubuntu" ]]; then
            $SUDO /usr/local/lib/uhd/utils/uhd_images_downloader.py
        fi
        if [[ "$OS_DISTRO" == "rhel" ]]; then
            $SUDO /usr/local/lib64/uhd/utils/uhd_images_downloader.py
        fi
    fi
Raphael Defosseux's avatar
Raphael Defosseux committed
300 301
    popd
    rm -rf /tmp/uhd
302 303 304 305 306 307
    ) >& $uhd_install_log
}

check_install_usrp_uhd_driver(){
    if [[ "$OS_DISTRO" == "ubuntu" ]]; then
        #first we remove old installation
308 309 310 311 312 313 314 315 316
        $SUDO apt-get remove uhd -y || true
        $SUDO apt-get remove uhd-host -y || true
        $SUDO apt-get remove libuhd-dev -y || true
        $SUDO apt-get remove libuhd003 -y || true
        $SUDO apt-get remove libuhd3.13.1 -y || true
        $SUDO apt-get remove libuhd3.14.0 -y || true
        $SUDO apt-get remove libuhd3.14.1 -y || true
        $SUDO apt-get remove libuhd3.15.0 -y || true
        local distribution=$(get_distribution_release)
317
        if [[ "$distribution" == "ubuntu18.04" || "$distribution" == "ubuntu20.04" || "$distribution" == "ubuntu22.04" ]]; then
318 319 320
            $SUDO apt-get remove libuhd4.0.0 -y || true
            $SUDO apt-get remove libuhd4.1.0 -y || true
        fi
321 322
        v=$(lsb_release -cs)
        $SUDO apt-add-repository --remove "deb http://files.ettus.com/binaries/uhd/repo/uhd/ubuntu/$v $v main"
323 324 325 326 327
        if [[ -v BUILD_UHD_FROM_SOURCE ]]; then
            $SUDO apt-get install -y libboost-all-dev libusb-1.0-0-dev doxygen python3-docutils python3-mako python3-numpy python3-requests python3-setuptools ninja-build
            install_usrp_uhd_driver_from_source
            return
        fi
328
        # The new USRP repository
329
        # Raphael Defosseux: Adding a loop on adding PPA because in CI the gpg key retrieve may
330 331 332 333 334 335 336 337 338 339 340 341 342 343 344
        # timeout due to proxy / network latencies in Eurecom on VM
        echo_info "\nAdding PPA repository ettusresearch/uhd\n"
        x=0
        while [ $x -le 5 ]
        do
            if $SUDO add-apt-repository ppa:ettusresearch/uhd -y
            then
                echo_info "add-apt-repository successful\n"
                break
            else
                echo_info "add-apt-repository failed, retrying...\n"
                sleep 30
            fi
            x=$((x + 1))
        done
345
        $SUDO apt-get update
346
        $SUDO apt-get -y install python-tk libboost-all-dev libusb-1.0-0-dev
347 348
        case "$(get_distribution_release)" in
          "ubuntu16.04")
349
            $SUDO apt-get -y install libuhd-dev libuhd3.15.0 uhd-host
350 351 352 353 354
            ;;
          "ubuntu18.04" | "ubuntu20.04" | "ubuntu22.04")
            $SUDO apt-get -y install libuhd-dev libuhd4.2.0 uhd-host
            ;;
        esac
355
    elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
Raphael Defosseux's avatar
Raphael Defosseux committed
356 357
        if [ $IS_CONTAINER -eq 0 ]
        then
358
            $SUDO $INSTALLER -y install python boost libusb-devel libusbx-devel boost-devel python-mako python-docutils $CMAKE
Raphael Defosseux's avatar
Raphael Defosseux committed
359 360
            $SUDO -H pip install requests
        else
361
            $SUDO $INSTALLER -y install boost boost-devel $CMAKE
Raphael Defosseux's avatar
Raphael Defosseux committed
362 363
            $SUDO pip3 install mako requests
        fi
364
        if [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "centos" ]]; then
Raphael Defosseux's avatar
Raphael Defosseux committed
365 366 367 368 369
            if [ $IS_CONTAINER -eq 0 ]
            then
                # until EPEL repo hasn't bumped UHD driver to >=3.10 in EPEL, build driver from source
                $SUDO $INSTALLER -y remove uhd uhd-devel uhd-firmware
            fi
370 371 372 373 374 375 376 377 378 379 380 381 382
            install_usrp_uhd_driver_from_source
        else
            $SUDO $INSTALLER -y install uhd uhd-devel uhd-firmware
        fi
    fi
}

install_usrp_uhd_driver() {
    if [[ "$OS_DISTRO" == "ubuntu" ]]; then
        # We move uhd-host apart because it depends on linux kernel version
        # On newer kernels, it fails to install
        $SUDO apt-get -y install uhd-host
    fi
383 384
    # quick workaround for RHE7.6
    local distribution=$(get_distribution_release)
385
    if [ -z $1 ]; then
386
      if [[ "$OS_DISTRO" == "rhel" ]]; then
387 388 389 390
          $SUDO /usr/local/bin/uhd_images_downloader
      else
          $SUDO uhd_images_downloader
      fi
391
    else
392
      if [[ "$OS_DISTRO" == "rhel" ]]; then
393 394 395 396
          $SUDO /usr/local/bin/uhd_images_downloader -i $1
      else
          $SUDO uhd_images_downloader -i $1
      fi
397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418
    fi
}

install_bladerf_driver_from_source(){
    bladerf_install_log=$OPENAIR_DIR/cmake_targets/log/bladerf_install_log.txt
    echo_info "\nInstalling BladeRF driver from sources. The log file for BladeRF driver installation is here: $bladerf_install_log "
    (
    cd /tmp
    echo "Downloading BladeRF driver"
    rm -rf /tmp/bladeRF
    git clone https://github.com/Nuand/bladeRF.git
    cd bladeRF
    git checkout tags/2016.06
    mkdir -p build
    cd build
    $CMAKE ../
    echo "Compiling BladeRF driver"
    make
    $SUDO make install
    $SUDO ldconfig
    echo "Downloading FPGA and firmware images"
    cd /tmp/bladeRF
419 420
    wget --tries=3 --retry-connrefused https://www.nuand.com/fx3/bladeRF_fw_latest.img
    wget --tries=3 --retry-connrefused https://www.nuand.com/fpga/hostedx40-latest.rbf
421 422 423 424 425 426 427 428
    sudo mkdir -p /usr/share/Nuand/bladeRF
    sudo mv bladeRF_fw_latest.img /usr/share/Nuand/bladeRF/bladeRF_fw.img
    sudo mv hostedx40-latest.rbf /usr/share/Nuand/bladeRF/hostedx40.rbf
    ) >& $bladerf_install_log
}

check_install_bladerf_driver(){
    if [[ "$OS_DISTRO" == "ubuntu" ]]; then
429 430 431
        $SUDO apt-get install -y  bladerf libbladerf-dev
        $SUDO apt-get install -y bladerf-firmware-fx3
        $SUDO apt-get install -y bladerf-fpga-hostedx40
432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450
   elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
        install_bladerf_driver_from_source
   else
        echo_error "BladeRF Installer for OAI does not support automatic build. Install BladeRF compiling sources manually from BladeRF website"
   fi
}

flash_firmware_bladerf() {
	$SUDO bladeRF-cli --flash-firmware /usr/share/Nuand/bladeRF/bladeRF_fw.img
}

check_install_lmssdr_driver(){
	if ( [ -d "/usr/local/include/lime" ] &&
             [ -f "/usr/local/include/lime/LimeSuite.h" ] )
	then
  		echo_success "Found lmssdr drivers and tools installed from source"
        else
                echo_error "lmssdr support implies installing lmssdr drivers and tools" \
                           " from sources. check:"
Laurent's avatar
Laurent committed
451
                echo_info "https://wiki.myriadrf.org/Lime_Suite"
452
                echo_fatal "Cannot compile lmssdr device"
453 454 455 456 457
	fi


}

458 459 460 461 462 463
install_soapy_from_source(){
    soapy_install_log=$OPENAIR_DIR/cmake_targets/log/soapy_install_log.txt
    echo_info "\nInstalling Soapy EcoSystem from source. The log file for Soapy installation is here: $soapy_install_log "
    (
    cd /tmp
    echo "Downloading SoapySDR"
464
    rm -rf /tmp/SoapySDR
Rahman Doost's avatar
Rahman Doost committed
465 466
    git clone -b soapy-sdr-0.7.0 --single-branch https://github.com/pothosware/SoapySDR.git
    cd SoapySDR
467 468 469 470 471 472 473 474 475 476
    #git checkout tags/release_003_010_001_001
    mkdir -p build
    cd build
    $CMAKE ../
    echo "Compiling SoapySDR"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
    cd /tmp
    echo "Downloading SoapyRemote"
477
    rm -rf /tmp/SoapyRemote
Rahman Doost's avatar
Rahman Doost committed
478 479
    git clone -b soapy-remote-0.5.0 --single-branch https://github.com/pothosware/SoapyRemote.git
    cd SoapyRemote
480 481 482
    #git checkout tags/release_003_010_001_001
    mkdir -p build
    cd build
483
    $CMAKE ../
484 485 486 487 488 489 490 491 492 493 494 495 496 497
    echo "Compiling SoapyRemote"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
    ) >& $soapy_install_log
}

install_soapy_iris_from_source(){
    iris_install_log=$OPENAIR_DIR/cmake_targets/log/iris_install_log.txt
    echo_info "\nInstalling Iris driver from source. The log file for Iris driver installation is here: $iris_install_log "
    (
    cd /tmp
    echo "Downloading SoapyIris"
    rm -rf /tmp/sklk-soapyiris
Rahman Doost's avatar
Rahman Doost committed
498
    git clone -b soapy-iris-2018.08.0.1 --single-branch https://github.com/skylarkwireless/sklk-soapyiris.git
499 500 501
    cd sklk-soapyiris
    mkdir -p build
    cd build
502
    $CMAKE ../
503 504 505 506 507 508 509 510 511 512
    echo "Compiling SoapyIris"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
    ) >& $iris_install_log
}

check_install_soapy () {
    #if [[ "$OS_DISTRO" == "ubuntu" ]]; then
        #first we remove old installation
Rahman Doost's avatar
Rahman Doost committed
513 514 515 516
    $SUDO apt-get remove -y soapysdr soapysdr-server libsoapysdr-dev python-soapysdr python3-soapysdr soapysdr-module-remote || true
        #$SUDO add-apt-repository -y ppa:myriadrf/drivers
        #$SUDO apt-get update
        #$SUDO apt-get install -y soapysdr soapysdr-server libsoapysdr-dev python-soapysdr python3-soapysdr soapysdr-module-remote
517 518 519

    #elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
    #    $SUDO $INSTALLER -y install software-properties-common python3-software-properties python-software-properties subversion git python3 python-numpy python3-numpy cmake swig python-dev
Rahman Doost's avatar
Rahman Doost committed
520
    install_soapy_from_source
521 522 523 524 525
    #fi
    install_soapy_iris_from_source

}

526 527
check_install_additional_tools (){
  $SUDO $INSTALLER update -y
528
  local optional_packages=""
529
  if [[ "$OS_DISTRO" == "ubuntu" ]]; then
530
    case "$(get_distribution_release)" in
531
        "ubuntu16.04"| "ubuntu18.04")
Robert Schmidt's avatar
Robert Schmidt committed
532
            optional_packages="python-dev python-pexpect python-numpy python-scipy python-matplotlib ctags"
533
            ;;
Robert Schmidt's avatar
Robert Schmidt committed
534 535
        "ubuntu20.04" | "ubuntu21.04" | "ubuntu22.04" )
            optional_packages="python3 python3-pip python3-dev python3-scipy python3-matplotlib universal-ctags"
536 537
            ;;
    esac
538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559
    PACKAGE_LIST="\
	check \
	dialog \
	dkms \
	gawk \
	libboost-all-dev \
	libpthread-stubs0-dev \
	openvpn \
	pkg-config \
	sshfs \
	swig  \
	tshark \
	uml-utilities \
	unzip  \
	valgrind  \
	vlan	  \
        ntpdate \
        iperf3 \
        android-tools-adb \
	wvdial \
        sshpass \
        bc \
560
        ntp"
561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604
  elif [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "centos" ]]; then
    PACKAGE_LIST="\
      check \
      dialog \
      dkms \
      gawk \
      boost-devel \
      openvpn \
      pkgconfig \
      pexpect \
      sshfs \
      swig  \
      wireshark \
      unzip  \
      valgrind  \
      vconfig	  \
      ctags \
      ntpdate \
      iperf3 \
      wvdial \
      numpy \
      sshpass \
      python2-paramiko \
      python-pyroute2 \
      python-netifaces \
      scipy \
      python-matplotlib"
  elif [[ "$OS_DISTRO" == "fedora" ]]; then
    PACKAGE_LIST=" \
      check \
      dialog \
      dkms \
      gawk \
      boost-devel \
      openvpn \
      pkgconfig \
      python-pexpect \
      sshfs \
      swig  \
      wireshark \
      unzip  \
      valgrind  \
      vconfig	  \
      ctags \
605
      ntpsec \
606 607 608 609
      iperf3 \
      wvdial \
      python-numpy \
      sshpass \
610
      python-paramiko \
611 612
      python-pyroute2 \
      python-netifaces \
613 614
      python-scipy \
      python-matplotlib"
615
  fi
616
    $SUDO $INSTALLER install -y $PACKAGE_LIST $optional_packages
617

618 619
  #The packages below are already installed for Redhat distros (RHEL, CentOS, Fedora)
  if [[ "$OS_DISTRO" == "ubuntu" ]]; then
620 621
    $SUDO -H pip install paramiko
    $SUDO -H pip install pyroute2 colorama
622 623 624 625
    log_netiface=$OPENAIR_DIR/cmake_targets/log/netiface_install_log.txt
    echo_info "Installing Netinterfaces package. The logfile for installation is in $log_netiface"
    (
    $SUDO rm -fr /tmp/netifaces-0.10.4.tar.gz /tmp/netifaces
626
    wget --tries=3 --retry-connrefused -P /tmp  https://pypi.python.org/packages/18/fa/dd13d4910aea339c0bb87d2b3838d8fd923c11869b1f6e741dbd0ff3bc00/netifaces-0.10.4.tar.gz
627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647
    tar -xzvf /tmp/netifaces-0.10.4.tar.gz -C /tmp
    cd /tmp/netifaces-0.10.4
    $SUDO python setup.py install
    cd -
    ) >& $log_netiface
  fi
}

check_install_oai_software() {
    local specific_packages=""
    if ! check_supported_distribution; then
        echo_error "Your distribution $(get_distribution_release) is not supported by oai !"
        exit 1
    fi
    $SUDO $INSTALLER update -y
  if [[ "$OS_DISTRO" == "ubuntu" ]]; then
    local LAPACK_LIBNAME="liblapack.so"
    local LAPACK_TARGET="/usr/lib/atlas-base/atlas/liblapack.so"
    $SUDO apt install -y software-properties-common
    case "$(get_distribution_release)" in
        "ubuntu16.04")
Robert Schmidt's avatar
Robert Schmidt committed
648
            specific_packages="libtasn1-6-dev libgnutls-dev libatlas-dev iproute libconfig8-dev iptables-dev libgcrypt11-dev python-pip pydb python guile-2.0-dev"
649
            ;;
650
        "ubuntu18.04")
Robert Schmidt's avatar
Robert Schmidt committed
651
            specific_packages="libtasn1-6-dev libgnutls28-dev iproute2 libconfig-dev iptables-dev libgcrypt11-dev python-pip pydb python guile-2.0-dev"
652 653 654 655
            LAPACK_LIBNAME="liblapack.so-x86_64-linux-gnu"
            LAPACK_TARGET="/usr/lib/x86_64-linux-gnu/atlas/liblapack.so"
            ;;
        "ubuntu20.04")
Robert Schmidt's avatar
Robert Schmidt committed
656
            specific_packages="libtasn1-6-dev libgnutls28-dev iproute2 libconfig-dev python guile-2.0-dev"
657 658 659 660
            LAPACK_LIBNAME="liblapack.so-x86_64-linux-gnu"
            LAPACK_TARGET="/usr/lib/x86_64-linux-gnu/atlas/liblapack.so"
            ;;
         "ubuntu21.04")
Robert Schmidt's avatar
Robert Schmidt committed
661 662 663 664 665 666
            specific_packages="libtasn1-6-dev libgnutls28-dev iproute2 libconfig-dev python guile-2.0-dev"
            LAPACK_LIBNAME="liblapack.so-x86_64-linux-gnu"
            LAPACK_TARGET="/usr/lib/x86_64-linux-gnu/atlas/liblapack.so"
            ;;
         "ubuntu22.04")
            specific_packages="libtasn1-6-dev libgnutls28-dev iproute2 libconfig-dev python2 guile-2.2-dev"
667 668 669 670 671 672 673 674 675 676
            LAPACK_LIBNAME="liblapack.so-x86_64-linux-gnu"
            LAPACK_TARGET="/usr/lib/x86_64-linux-gnu/atlas/liblapack.so"
            ;;
    esac
    $SUDO apt-get install -y \
    $specific_packages \
	autoconf  \
	automake  \
	bison  \
	build-essential \
677
	$CMAKE \
678
	cmake-curses-gui  \
679
	curl \
laurent's avatar
laurent committed
680
        ninja-build \
681 682 683 684 685
	doxygen \
	doxygen-gui \
	texlive-latex-base \
	ethtool \
	flex  \
686 687
        g++ \
        gcc \
688 689 690 691 692 693 694 695
	gdb  \
	git \
	graphviz \
	gtkwave \
	iperf \
	iptables \
	libatlas-base-dev \
	libblas-dev \
696 697
	liblapack-dev \
	liblapacke-dev \
698 699 700 701 702 703 704 705 706
	libffi-dev \
	libforms-bin \
	libforms-dev \
	libgmp-dev \
	libgtk-3-dev \
	libidn2-0-dev  \
	libidn11-dev \
	libmysqlclient-dev  \
	libpython2.7-dev \
707
        libreadline-dev \
708 709 710 711 712 713 714 715 716 717 718 719 720 721 722
	libsctp1  \
	libsctp-dev  \
	libssl-dev  \
	libtool  \
	libusb-1.0-0-dev \
	libxml2 \
	libxml2-dev  \
	libxslt1-dev \
	octave-signal \
	openssh-client \
	openssh-server \
	openssl \
	subversion \
	xmlstarlet \
	wget \
723 724
	libxpm-dev \
        libboost-all-dev
725 726 727 728 729 730 731 732 733 734 735 736

    $SUDO update-alternatives --set "$LAPACK_LIBNAME" "$LAPACK_TARGET"

    $SUDO apt-get install -y nettle-dev nettle-bin
  elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
    if [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "centos" ]]; then
      if rpm -q epel-release > /dev/null; then
        echo "EPEL repos already present. Good."
      else
        echo "EPEL repos not present. Installing them."
        $SUDO $INSTALLER install -y https://dl.fedoraproject.org/pub/epel/epel-release-latest-7.noarch.rpm
      fi
Cedric Roux's avatar
Cedric Roux committed
737
      $SUDO $INSTALLER install -y python-epdb vim-common
738
    fi
739

740 741 742 743 744 745 746 747 748
    $SUDO $INSTALLER install -y \
      autoconf \
      automake \
      bc \
      bison \
      $CMAKE \
      doxygen \
      ethtool \
      flex \
749 750
      g++ \
      gcc \
751 752 753 754 755 756 757 758 759 760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780
      gdb \
      git \
      graphviz \
      gtkwave \
      guile-devel \
      iperf \
      iproute \
      iptables \
      iptables-devel \
      atlas-devel \
      blas-devel \
      libconfig-devel \
      libffi-devel \
      xforms \
      xforms-devel \
      libgcrypt-devel \
      gmp-devel \
      gtk3-devel \
      libidn2-devel  \
      libidn-devel \
      mariadb-devel \
      lksctp-tools \
      lksctp-tools-devel \
      openssl-devel \
      libtasn1 \
      libtool \
      libusb-devel \
      libxml2 \
      libxml2-devel \
      libxslt-devel \
781 782
      ninja-build \
      make \
783 784 785 786 787 788
      openssh-clients \
      openssh-server \
      openssl \
      patch \
      psmisc \
      python \
789
      readline-devel \
790 791 792 793 794 795 796 797 798 799 800 801
      subversion \
      xmlstarlet \
      python-pip \
      wget \
      kernel-headers \
      kernel-devel \
      nettle-devel \
      gnutls-devel \
      libXpm-devel \
      lapack \
      lapack-devel \
      blas \
Robert Schmidt's avatar
Robert Schmidt committed
802
      blas-devel
803 804
  fi

805
    install_asn1c_from_source $1
806
    install_simde_from_source $1
807 808 809 810 811 812 813
}

install_asn1c_from_source(){
    asn1_install_log=$OPENAIR_DIR/cmake_targets/log/asn1c_install_log.txt
    echo_info "\nInstalling ASN1. The log file for ASN1 installation is here: $asn1_install_log "
    (
    $SUDO rm -rf /tmp/asn1c
814
    # GIT_SSL_NO_VERIFY=true git clone https://gitlab.eurecom.fr/oai/asn1c.git /tmp/asn1c
Cedric Roux's avatar
Cedric Roux committed
815
    git clone https://gitlab.eurecom.fr/oai/asn1c.git /tmp/asn1c
816
    cd /tmp/asn1c
Cedric Roux's avatar
Cedric Roux committed
817 818 819
    # better to use a given commit than a branch in case the branch
    # is updated and requires modifications in the source of OAI
    #git checkout velichkov_s1ap_plus_option_group
820
    git checkout f12568d617dbf48497588f8e227d70388fa217c9
821
    autoreconf -iv
822 823 824 825 826
    ./configure
    make -j`nproc`
    $SUDO make install
    cd -
    $SUDO ldconfig
827 828 829
    if [[ -v CI_ENV ]]; then
        $SUDO rm -rf /tmp/asn1c
    fi
830 831 832
    ) > $asn1_install_log 2>&1
}

833 834
install_simde_from_source(){
    echo_info "\nInstalling SIMDE from source without test cases (header files only)"
835
    cd /tmp
836 837 838 839 840 841 842
    $SUDO rm -rf /tmp/simde
    git clone https://github.com/simd-everywhere/simde-no-tests.git /tmp/simde
    cd /tmp/simde
    # brute force copy into /usr/include
    $SUDO \cp -rv ../simde /usr/include
}

843
#################################################
844
# 2. compile
845 846 847
################################################

install_nas_tools() {
Laurent THOMAS's avatar
Laurent THOMAS committed
848 849 850 851
  echo_success "generate .ue_emm.nvram .ue.nvram"
  ./nvram --gen -c $1 -o $2 > "$3"
  echo_success "generate .usim.nvram"
  ./usim --gen -c $1 -o $2 >> "$3"
852 853 854 855 856 857 858 859 860 861 862
}


################################
# set_openair_env
###############################
set_openair_env(){
    fullpath=`readlink -f $BASH_SOURCE`
    [ -f "/.$fullpath" ] || fullpath=`readlink -f $PWD/$fullpath`
    openair_path=${fullpath%/cmake_targets/*}
    openair_path=${openair_path%/targets/*}
863
    openair_path=${openair_path%/openair[123]/*}
864 865 866 867 868 869 870 871 872 873 874 875 876 877 878 879
    export OPENAIR_DIR=$openair_path
    export OPENAIR1_DIR=$openair_path/openair1
    export OPENAIR2_DIR=$openair_path/openair2
    export OPENAIR3_DIR=$openair_path/openair3
    export OPENAIR_TARGETS=$openair_path/targets
}

################################
# Function to killall the subprocesses when Ctrl-C Key is hit
###############################
function handle_ctrl_c(){
CURPID=$$
ppid=$$
arraycounter=1
echo_info "** Trapped CTRL-C. Killing all subprocesses now..."
echo_info "** Calling sync now..."
880
sync
881 882 883 884 885 886 887 888 889 890 891 892 893 894 895 896 897
while true
do
        FORLOOP=FALSE
        # Get all the child process id
        for i in `ps -ef| awk '$3 == '$ppid' { print $2 }'`
        do
                if [ $i -ne $CURPID ] ; then
                        procid[$arraycounter]=$i
                        arraycounter=`expr $arraycounter + 1`
                        ppid=$i
                        FORLOOP=TRUE
                fi
        done
        if [ "$FORLOOP" = "FALSE" ] ; then
           arraycounter=`expr $arraycounter - 1`
           ## We want to kill child process id first and then parent id's
           while [ $arraycounter -ne 0 ]
898
           do
899 900 901 902 903 904 905 906 907 908 909
             echo "first we send ctrl-c to program"
             $SUDO kill -INT "${procid[$arraycounter]}"
             sleep 5
             echo "Now we force kill if that didn't work"
             $SUDO kill -9 "${procid[$arraycounter]}" >/dev/null
             arraycounter=`expr $arraycounter - 1`
           done
         exit
        fi
done
}